org.apache.coyote.http2

## Class Http2Protocol

- java.lang.Object
- - org.apache.coyote.http2.Http2Protocol

- All Implemented Interfaces:
    UpgradeProtocol

      public class Http2Protocol
      extends Object
      implements UpgradeProtocol

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Http2Protocol()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `accept(Request request)` Allows the implementation to examine the request and accept or reject it based on what it finds.
    `String` | `getAllowedTrailerHeaders()`
    `byte[]` | `getAlpnIdentifier()`
    `String` | `getAlpnName()`
    `String` | `getHttpUpgradeName(boolean isSSLEnabled)`
    `int` | `getInitialWindowSize()`
    `InternalHttpUpgradeHandler` | `getInternalUpgradeHandler(Adapter adapter, Request coyoteRequest)`
    `long` | `getKeepAliveTimeout()`
    `int` | `getMaxConcurrentStreamExecution()`
    `long` | `getMaxConcurrentStreams()`
    `int` | `getMaxHeaderCount()`
    `int` | `getMaxHeaderSize()`
    `int` | `getMaxTrailerCount()`
    `int` | `getMaxTrailerSize()`
    `Processor` | `getProcessor(SocketWrapperBase<?> socketWrapper, Adapter adapter)`
    `long` | `getReadTimeout()`
    `long` | `getWriteTimeout()`
    `void` | `setAllowedTrailerHeaders(String commaSeparatedHeaders)`
    `void` | `setInitialWindowSize(int initialWindowSize)`
    `void` | `setInitiatePingDisabled(boolean initiatePingDisabled)`
    `void` | `setKeepAliveTimeout(long keepAliveTimeout)`
    `void` | `setMaxConcurrentStreamExecution(int maxConcurrentStreamExecution)`
    `void` | `setMaxConcurrentStreams(long maxConcurrentStreams)`
    `void` | `setMaxHeaderCount(int maxHeaderCount)`
    `void` | `setMaxHeaderSize(int maxHeaderSize)`
    `void` | `setMaxTrailerCount(int maxTrailerCount)`
    `void` | `setMaxTrailerSize(int maxTrailerSize)`
    `void` | `setReadTimeout(long readTimeout)`
    `void` | `setWriteTimeout(long writeTimeout)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Http2Protocol

          public Http2Protocol()

  - ### Method Detail

    - #### getHttpUpgradeName

          public String getHttpUpgradeName(boolean isSSLEnabled)

      Specified by:
        `getHttpUpgradeName` in interface `UpgradeProtocol`
      Parameters:
        `isSSLEnabled` - Is this for a connector that is configured to support TLS. Some protocols (e.g. HTTP/2) only support HTTP upgrade over non-secure connections.
      Returns:
        The name that clients will use to request an upgrade to this protocol via an HTTP/1.1 upgrade request or `null` if upgrade via an HTTP/1.1 upgrade request is not supported.

    - #### getAlpnIdentifier

          public byte[] getAlpnIdentifier()

      Specified by:
        `getAlpnIdentifier` in interface `UpgradeProtocol`
      Returns:
        The byte sequence as listed in the IANA registry for this protocol or `null` if upgrade via ALPN is not supported.

    - #### getAlpnName

          public String getAlpnName()

      Specified by:
        `getAlpnName` in interface `UpgradeProtocol`
      Returns:
        The name of the protocol as listed in the IANA registry if and only if `UpgradeProtocol.getAlpnIdentifier()` returns the UTF-8 encoding of this name. If `UpgradeProtocol.getAlpnIdentifier()` returns some other byte sequence, then this method returns the empty string. If upgrade via ALPN is not supported then `null` is returned.

    - #### getProcessor

          public Processor getProcessor(SocketWrapperBase<?> socketWrapper,
                               Adapter adapter)

      Specified by:
        `getProcessor` in interface `UpgradeProtocol`
      Parameters:
        `socketWrapper` - The socketWrapper for the connection that requires a processor
        `adapter` - The Adapter instance that provides access to the standard Engine/Host/Context/Wrapper processing chain
      Returns:
        A processor instance for processing a connection using this protocol.

    - #### getInternalUpgradeHandler

          public InternalHttpUpgradeHandler getInternalUpgradeHandler(Adapter adapter,
                                                             Request coyoteRequest)

      Specified by:
        `getInternalUpgradeHandler` in interface `UpgradeProtocol`
      Parameters:
        `adapter` - The Adapter to use to configure the new upgrade handler
        `coyoteRequest` - A copy (may be incomplete) of the request that triggered the upgrade
      Returns:
        An instance of the HTTP upgrade handler for this protocol

    - #### accept

          public boolean accept(Request request)

      Description copied from interface: `UpgradeProtocol`
      Allows the implementation to examine the request and accept or reject it based on what it finds.
      Specified by:
        `accept` in interface `UpgradeProtocol`
      Parameters:
        `request` - The request that included an upgrade header for this protocol
      Returns:
        `true` if the request is accepted, otherwise `false`

    - #### getReadTimeout

          public long getReadTimeout()

    - #### setReadTimeout

          public void setReadTimeout(long readTimeout)

    - #### getKeepAliveTimeout

          public long getKeepAliveTimeout()

    - #### setKeepAliveTimeout

          public void setKeepAliveTimeout(long keepAliveTimeout)

    - #### getWriteTimeout

          public long getWriteTimeout()

    - #### setWriteTimeout

          public void setWriteTimeout(long writeTimeout)

    - #### getMaxConcurrentStreams

          public long getMaxConcurrentStreams()

    - #### setMaxConcurrentStreams

          public void setMaxConcurrentStreams(long maxConcurrentStreams)

    - #### getMaxConcurrentStreamExecution

          public int getMaxConcurrentStreamExecution()

    - #### setMaxConcurrentStreamExecution

          public void setMaxConcurrentStreamExecution(int maxConcurrentStreamExecution)

    - #### getInitialWindowSize

          public int getInitialWindowSize()

    - #### setInitialWindowSize

          public void setInitialWindowSize(int initialWindowSize)

    - #### setAllowedTrailerHeaders

          public void setAllowedTrailerHeaders(String commaSeparatedHeaders)

    - #### getAllowedTrailerHeaders

          public String getAllowedTrailerHeaders()

    - #### setMaxHeaderCount

          public void setMaxHeaderCount(int maxHeaderCount)

    - #### getMaxHeaderCount

          public int getMaxHeaderCount()

    - #### setMaxHeaderSize

          public void setMaxHeaderSize(int maxHeaderSize)

    - #### getMaxHeaderSize

          public int getMaxHeaderSize()

    - #### setMaxTrailerCount

          public void setMaxTrailerCount(int maxTrailerCount)

    - #### getMaxTrailerCount

          public int getMaxTrailerCount()

    - #### setMaxTrailerSize

          public void setMaxTrailerSize(int maxTrailerSize)

    - #### getMaxTrailerSize

          public int getMaxTrailerSize()

    - #### setInitiatePingDisabled

          public void setInitiatePingDisabled(boolean initiatePingDisabled)

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.